# Copyright (c) 2017, MD2K Center of Excellence
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# * Redistributions of source code must retain the above copyright notice, this
# list of conditions and the following disclaimer.
#
# * Redistributions in binary form must reproduce the above copyright notice,
# this list of conditions and the following disclaimer in the documentation
# and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

from cerebralcortex.kernel.DataStoreEngine.Data.LoadData import LoadData
from cerebralcortex.kernel.DataStoreEngine.Data.StoreData import StoreData

class Data(LoadData, StoreData):
    def __init__(self, CC_obj):
        """
        :param sparkContext:
        :param sparkContext:
        :param configuration:
        :param sqlContext:
        """
        # google proto buf
        # julia lang

        self.CC_obprj = CC_obj
        self.configuration = CC_obj.configuration

        if hasattr(CC_obj, "sqlContext"):
            self.sqlContext = CC_obj.sqlContext

        self.hostIP = self.configuration['cassandra']['host']
        self.hostPort = self.configuration['cassandra']['port']
        self.keyspaceName = self.configuration['cassandra']['keyspace']
        self.dbUser = self.configuration['cassandra']['db_user']
        self.dbPassword = self.configuration['cassandra']['db_pass']
        self.datapointTable = self.configuration['cassandra']['datapoint_table']

        self.influxdbIP = self.configuration['influxdb']['host']
        self.influxdbPort = self.configuration['influxdb']['port']
        self.influxdbDatabase = self.configuration['influxdb']['database']
        self.influxdbUser = self.configuration['influxdb']['db_user']
        self.influxdbPassword = self.configuration['influxdb']['db_pass']

